"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _baseColors = require("grape-theme/dist/base-colors");

var _color = _interopRequireDefault(require("color"));

var _classnames = _interopRequireDefault(require("classnames"));

var _random = _interopRequireDefault(require("lodash/random"));

var _jss = _interopRequireDefault(require("../../jss"));

var _svg2base = _interopRequireDefault(require("../../jss-utils/svg2base64"));

var _grape = _interopRequireDefault(require("./grape.svg"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Spinner renders a graphic after a `delay` if its not unmounted.
 */
var steps = 101;
var sizesMap = {
  s: 32,
  m: 64
};

var _animationName = function () {
  var id = (0, _random["default"])(10000);
  return function (size) {
    return "grape-logo-".concat(size, "-").concat(id);
  };
}();

var keyframes = Object.keys(sizesMap).reduce(function (styles, size) {
  // eslint-disable-next-line no-param-reassign
  styles["@keyframes ".concat(_animationName(size))] = {
    to: {
      backgroundPositionX: -sizesMap[size] * steps
    }
  };
  return styles;
}, {});

var styles = _objectSpread(_objectSpread({}, keyframes), {}, {
  spinner: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    position: 'absolute',
    zIndex: 1,
    top: 0,
    left: 0,
    right: 0,
    bottom: 0
  },
  animation: {
    width: function width(_ref) {
      var size = _ref.size;
      return sizesMap[size];
    },
    height: function height(_ref2) {
      var size = _ref2.size;
      return sizesMap[size];
    },
    background: {
      image: "url(".concat((0, _svg2base["default"])(_grape["default"]), ")"),
      repeat: 'no-repeat',
      position: [0, 0],
      size: 'auto 100%'
    },
    animation: {
      duration: '3s',
      timingFunction: "steps(".concat(steps, ")"),
      iterationCount: 'infinite'
    },
    animationName: function animationName(_ref3) {
      var size = _ref3.size;
      return _animationName(size);
    }
  },
  overlay: {
    background: (0, _color["default"])(_baseColors.white).alpha(0.7).rgbaString()
  }
});

var Spinner = /*#__PURE__*/function (_PureComponent) {
  _inherits(Spinner, _PureComponent);

  var _super = _createSuper(Spinner);

  function Spinner(props) {
    var _this;

    _classCallCheck(this, Spinner);

    _this = _super.call(this, props);
    _this.state = {
      active: !props.delay
    };
    return _this;
  }

  _createClass(Spinner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.state.active) return;
      this.timeoutId = setTimeout(function () {
        _this2.setState({
          active: true
        });
      }, this.props.delay);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(props) {
      this.setState({
        active: !props.delay
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timeoutId);
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.state.active) return null;
      var _this$props = this.props,
          classes = _this$props.classes,
          overlay = _this$props.overlay,
          className = _this$props.className;
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: (0, _classnames["default"])(classes.spinner, overlay && classes.overlay, className)
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: classes.animation
      }));
    }
  }]);

  return Spinner;
}(_react.PureComponent);

_defineProperty(Spinner, "propTypes", {
  classes: _propTypes["default"].object.isRequired,
  delay: _propTypes["default"].number,
  overlay: _propTypes["default"].bool,
  // eslint-disable-next-line react/no-unused-prop-types
  size: _propTypes["default"].oneOf(['s', 'm']),
  className: _propTypes["default"].string
});

_defineProperty(Spinner, "defaultProps", {
  delay: 1000,
  overlay: false,
  size: 'm',
  className: null
});

var _default = (0, _jss["default"])(styles)(Spinner);

exports["default"] = _default;