"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _excluded = ["variant"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var colors = {
  dark: ['#0B69C6', '#0080FF', '#032950', '#99449B', '#8C448E', '#B158B3', '#954197'],
  light: ['#FFEAC6', '#FFEAC6', '#FFEAC6', '#F5A623', '#F5A623', '#F5A623', '#F5A623']
};

var MagicWand = function MagicWand(_ref) {
  var variant = _ref.variant,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement("svg", _extends({
    width: "24",
    height: "24",
    viewBox: "284 335 24 24",
    xmlns: "http://www.w3.org/2000/svg"
  }, rest), /*#__PURE__*/_react["default"].createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][0],
    d: "M298.952 344.048l-.971-.302-13.504 12.823a1.382 1.382 0 1 0 1.955 1.954l12.822-13.503-.302-.972z"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][1],
    d: "M284.477 356.57c-.09.089-.159.19-.218.294.06.105.129.206.218.296.54.539 1.414.539 1.955 0l12.466-13.13-.917-.284-13.504 12.823z"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][2],
    d: "M297.98 343.746l-2.577 2.447 1.07.333.334 1.07 2.447-2.576-.302-.972z"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][3],
    d: "M307.823 344.302a.962.962 0 0 0-.086-1.012l-2.01-2.693 1.079-3.183c.235-.694-.526-1.454-1.219-1.22l-3.184 1.08-2.694-2.011a.96.96 0 0 0-1.535.783l.043 3.36-2.744 1.942a.962.962 0 0 0 .27 1.703l3.21.997.997 3.211a.969.969 0 0 0 .768.664.963.963 0 0 0 .934-.395l1.942-2.744 3.361.043a.96.96 0 0 0 .868-.525z"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][4],
    d: "M305.587 336.194l-3.184 1.08-2.694-2.012a.96.96 0 0 0-1.535.784l.043 3.36-2.744 1.942a.962.962 0 0 0 .27 1.702l3.21.998 7.592-7.592c-.248-.248-.612-.38-.958-.262z"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][5],
    d: "M303.583 344.797l3.371.03a.96.96 0 0 0 .783-1.537l-2.011-2.693 1.08-3.183c.234-.694-.526-1.454-1.22-1.22l-3.183 1.08-.017-.013 1.197 7.536z"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    fill: colors[variant][6],
    d: "M302.845 340.155l3.7-3.699c-.248-.248-.611-.379-.958-.262l-3.184 1.08-.017-.013.46 2.894z"
  })));
};

MagicWand.propTypes = {
  variant: _propTypes["default"].oneOf(['dark', 'light'])
};
MagicWand.defaultProps = {
  variant: 'dark'
};
var _default = MagicWand;
exports["default"] = _default;