"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.create = create;
Object.defineProperty(exports, "getOptions", {
  enumerable: true,
  get: function get() {
    return _utils.getOptions;
  }
});
Object.defineProperty(exports, "isGrapeUrl", {
  enumerable: true,
  get: function get() {
    return _utils.isGrapeUrl;
  }
});

var _User = _interopRequireDefault(require("./classes/User"));

var _Search = _interopRequireDefault(require("./classes/Search"));

var _Room = _interopRequireDefault(require("./classes/Room"));

var _Emoji = _interopRequireDefault(require("./classes/Emoji"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var types = {
  user: _User["default"],
  customEmoji: _Emoji["default"],
  emoji: _Emoji["default"],
  search: _Search["default"],
  room: _Room["default"]
};

function create(type, options) {
  var Obj = types[type] || _Search["default"];
  return new Obj(options);
}