"use strict";

var _expect = _interopRequireDefault(require("expect.js"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// eslint-disable-next-line import/no-extraneous-dependencies
describe('grape-objects: utils', function () {
  describe('encodeMdLink', function () {
    it('encode parentheses', function () {
      var encoded = (0, _utils.encodeMdLink)('something_(bad)');
      (0, _expect["default"])(encoded).to.be('something_%28bad%29');
    });
    it('encode brackets', function () {
      var encoded = (0, _utils.encodeMdLink)('something_[bad]');
      (0, _expect["default"])(encoded).to.be('something_%5bbad%5d');
    });
    it('encode spaces', function () {
      var encoded = (0, _utils.encodeMdLink)('string with spaces');
      (0, _expect["default"])(encoded).to.be('string%20with%20spaces');
    });
    it('encode everything', function () {
      var encoded = (0, _utils.encodeMdLink)('cg://link with[spaces](etc)');
      (0, _expect["default"])(encoded).to.be('cg://link%20with%5bspaces%5d%28etc%29');
    });
  });
  describe('isGrapeUrl', function () {
    it('should detect cg protocol', function () {
      (0, _expect["default"])((0, _utils.isGrapeUrl)('cg://something')).to.be(true);
      (0, _expect["default"])((0, _utils.isGrapeUrl)('http://something')).to.be(false);
    });
  });
});