"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "jss", {
  enumerable: true,
  get: function get() {
    return _reactJss.jss;
  }
});
Object.defineProperty(exports, "ThemeProvider", {
  enumerable: true,
  get: function get() {
    return _reactJss.ThemeProvider;
  }
});
Object.defineProperty(exports, "JssProvider", {
  enumerable: true,
  get: function get() {
    return _reactJss.JssProvider;
  }
});
exports["default"] = exports.styled = exports.Styled = exports.inlineStyle = void 0;

var _reactJss = _interopRequireWildcard(require("react-jss"));

var _jss = require("jss");

var _jssIsolate = _interopRequireDefault(require("jss-isolate"));

var _jssExtend = _interopRequireDefault(require("jss-extend"));

var _jssDefaultUnit = _interopRequireDefault(require("jss-default-unit"));

var _jssVendorPrefixer = _interopRequireDefault(require("jss-vendor-prefixer"));

var _jssPropsSort = _interopRequireDefault(require("jss-props-sort"));

var _jssExpand = _interopRequireDefault(require("jss-expand"));

var _jssIncreaseSpecificity = _interopRequireDefault(require("jss-increase-specificity"));

var _createStyled = _interopRequireDefault(require("styled-jss/createStyled"));

var _muiTheme = require("../mui-theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var jssInline = (0, _jss.create)({
  plugins: [(0, _jssExtend["default"])(), (0, _jssDefaultUnit["default"])(), (0, _jssExpand["default"])(), (0, _jssVendorPrefixer["default"])(), (0, _jssPropsSort["default"])()]
});

var inlineStyle = function inlineStyle(style) {
  return jssInline.createRule(style).toJSON();
}; // Used by material-ui


exports.inlineStyle = inlineStyle;
_reactJss.jss.options.insertionPoint = 'grape-jss';

_reactJss.jss.use((0, _jssIncreaseSpecificity["default"])({
  repeat: 1
})).use((0, _jssIsolate["default"])({
  isolate: false,
  reset: ['all', {
    display: 'inline-block',
    fontFamily: _muiTheme.typographyConstants.fontFamily,
    fontSize: _muiTheme.typographyConstants.fontSize,
    boxSizing: 'border-box',
    textRendering: 'optimizeLegibility',
    color: _muiTheme.palette.text.primary
  }]
}));

var Styled = (0, _createStyled["default"])(_reactJss.jss);
exports.Styled = Styled;
var styled = Styled();
exports.styled = styled;

var _default = function _default(styles) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return (0, _reactJss["default"])(styles, _objectSpread({
    inject: ['classes', 'sheet', 'theme'],
    isolate: true
  }, options));
};

exports["default"] = _default;