"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MuiPopover = exports.MuiChip = exports.MuiButton = exports.MuiFormLabel = exports.MuiInput = exports.MuiMenuItem = exports.MuiLinearProgress = void 0;

var _sizes = require("grape-theme/dist/sizes");

var _palette = _interopRequireDefault(require("./palette"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var MuiLinearProgress = {
  root: {
    height: 9,
    borderRadius: _sizes.borderRadius.big
  },
  determinateBar1: {
    background: {
      image: '-webkit-gradient(linear, 0 0, 100% 100%, color-stop(.25, rgba(255, 255, 255, .2)), color-stop(.25, rgba(0, 0, 0, 0)), color-stop(.5, rgba(0, 0, 0, 0)), color-stop(.5, rgba(255, 255, 255, .2)), color-stop(.75, rgba(255, 255, 255, .2)), color-stop(.75, rgba(0, 0, 0, 0)), to(rgba(0, 0, 0, 0)) )',
      size: [20, 20]
    },
    animation: 'mui-indeterminate2 2s linear infinite'
  },
  // FIXME it should not be using animation designed for indeterminate style progress,
  // the new validation of mui doesn't allows to use names which mui isn't using already.
  // Should be fixed in JSS by allowing keyframes inside of the rules and evtl with auto
  // generated name https://github.com/cssinjs/jss/issues/346
  '@keyframes mui-indeterminate2': {
    '0%': {
      left: 0,
      right: 0,
      backgroundPosition: [0, 0]
    },
    '60%': {
      left: 0,
      right: 0
    },
    '100%': {
      left: 0,
      right: 0,
      backgroundPosition: [20, 20]
    }
  }
};
exports.MuiLinearProgress = MuiLinearProgress;
var MuiMenuItem = {
  root: {
    height: 'auto'
  }
};
exports.MuiMenuItem = MuiMenuItem;
var inputHorizontalSpacing = 10;
var MuiInput = {
  root: {
    border: {
      width: 1,
      style: 'solid',
      color: _palette["default"].grey[200],
      radius: _sizes.borderRadius.big
    },
    padding: [0, inputHorizontalSpacing]
  },
  formControl: {
    marginTop: 5,
    marginBottom: 5
  },
  focused: {
    borderColor: _palette["default"].secondary.A200
  },
  error: {
    borderColor: _palette["default"].error[500]
  }
};
exports.MuiInput = MuiInput;
var MuiFormLabel = {
  root: {
    marginLeft: inputHorizontalSpacing
  },
  focused: {
    color: _palette["default"].text.primary
  },
  error: {
    color: _palette["default"].error[500]
  }
};
exports.MuiFormLabel = MuiFormLabel;
var MuiButton = {
  root: {
    textTransform: 'none',
    height: 'auto',
    padding: [0, 14],
    '&[href]': {
      padding: 0,
      backgroundColor: 'transparent',
      color: _palette["default"].secondary.A200,
      fontSize: 'inherit'
    },
    '&[href]:hover': {
      color: _palette["default"].secondary.A100
    }
  },
  raised: {
    border: {
      width: 1,
      style: 'solid',
      color: _palette["default"].grey[300],
      radius: _sizes.borderRadius.big
    },
    backgroundColor: _palette["default"].common.white,
    padding: [4, 14],
    boxShadow: 'none',
    '&:hover': {
      backgroundColor: _palette["default"].grey.A100,
      '&$disabled': {
        backgroundColor: _palette["default"].text.divider
      }
    },
    '&, &$keyboardFocused, &:active, &$disabled': {
      boxShadow: 'none'
    }
  },
  raisedPrimary: {
    backgroundColor: _palette["default"].primary[500],
    borderColor: _palette["default"].primary[500],
    color: _palette["default"].primary[100],
    '&:hover': {
      backgroundColor: _palette["default"].primary[700],
      borderColor: _palette["default"].primary[700],
      color: _palette["default"].primary[100]
    }
  },
  raisedAccent: {
    backgroundColor: _palette["default"].error[500],
    borderColor: _palette["default"].error[500],
    '&:hover': {
      backgroundColor: _palette["default"].error[700],
      borderColor: _palette["default"].error[700],
      color: _palette["default"].primary[100]
    }
  }
};
exports.MuiButton = MuiButton;
var MuiChip = {
  root: {
    height: 'auto',
    padding: [5, 0]
  },
  label: {
    isolate: false
  }
};
exports.MuiChip = MuiChip;
var MuiPopover = {
  paper: {
    borderRadius: _sizes.borderRadius.bigger
  }
};
exports.MuiPopover = MuiPopover;