"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var raw = _interopRequireWildcard(require("./raw"));

var _jss = _interopRequireDefault(require("../jss"));

var _excluded = ["classes", "className", "name"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Currently our svgs are strings.
 * To render svg as a component without wrappers, we need to extract
 * the inner contents of svg tag and its attributes.
 */
var getData = function () {
  var div = document.createElement('div');
  var cache = {};
  var attrNames = ['width', 'height', 'viewBox', 'xmlns'];
  return function (name) {
    if (!name) return '';
    if (cache[name]) return cache[name];
    var data = {};
    cache[name] = data;
    div.innerHTML = raw[name];
    var svg = div.firstChild;
    data.html = svg.innerHTML;
    data.attrs = attrNames.reduce(function (attrs, attr) {
      // eslint-disable-next-line no-param-reassign
      attrs[attr] = svg.getAttribute(attr);
      return attrs;
    }, {});
    return data;
  };
}();

var Icon = function Icon(_ref) {
  var classes = _ref.classes,
      className = _ref.className,
      name = _ref.name,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _getData = getData(name),
      html = _getData.html,
      attrs = _getData.attrs; // eslint-disable-next-line no-param-reassign


  delete rest.sheet;
  return /*#__PURE__*/_react["default"].createElement("svg", _extends({}, attrs, {
    dangerouslySetInnerHTML: {
      __html: html
    },
    className: (0, _classnames["default"])(classes.icon, className)
  }, rest));
};

Icon.propTypes = {
  classes: _propTypes["default"].object.isRequired,
  name: _propTypes["default"].string.isRequired,
  className: _propTypes["default"].string
};
Icon.defaultProps = {
  className: undefined
};
var styles = {
  icon: {
    isolate: false,
    display: 'inline-block',
    height: '1em',
    width: '1em',
    maxWidth: '100%',
    userSelect: 'none',
    fill: 'currentColor'
  }
};

var _default = (0, _jss["default"])(styles)(Icon);

exports["default"] = _default;