"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = create;

var _toArray = _interopRequireDefault(require("lodash/toArray"));

var _svg2base = _interopRequireDefault(require("../jss-utils/svg2base64"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var List = /*#__PURE__*/function () {
  function List(dom, list) {
    _classCallCheck(this, List);

    this.dom = dom;
    this.list = (0, _toArray["default"])(list);
  }

  _createClass(List, [{
    key: "each",
    value: function each(fn) {
      this.list.forEach(fn);
      return this;
    }
  }, {
    key: "attr",
    value: function attr(name, value) {
      this.each(function (node) {
        return node.setAttribute(name, value);
      });
      return this;
    }
  }, {
    key: "data",
    value: function data(encoding) {
      return (0, _svg2base["default"])(this.svg(), encoding);
    }
  }, {
    key: "svg",
    value: function svg() {
      return this.dom.el.innerHTML;
    }
  }, {
    key: "node",
    value: function node() {
      return this.dom.el.firstChild;
    }
  }]);

  return List;
}();

var Dom = /*#__PURE__*/function () {
  function Dom(svg) {
    _classCallCheck(this, Dom);

    this.el = document.createElement('div');
    this.el.innerHTML = svg;
  }

  _createClass(Dom, [{
    key: "find",
    value: function find(query) {
      return new List(this, this.el.querySelectorAll(query));
    }
  }]);

  return Dom;
}();

function create(svg) {
  return new Dom(svg);
}