"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getColored;

var raw = _interopRequireWildcard(require("./raw"));

var _dom = _interopRequireDefault(require("./dom"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var cache = {};
/**
 * Modifies `fill` and `stroke` attribute of `path`, caches the resulting string.
 */

function getColored(_ref) {
  var name = _ref.name,
      color = _ref.color,
      _ref$format = _ref.format,
      format = _ref$format === void 0 ? 'data' : _ref$format,
      _ref$replaceColor = _ref.replaceColor,
      replaceColor = _ref$replaceColor === void 0 ? 'currentColor' : _ref$replaceColor;
  var key = name + color + format;

  if (!cache[key]) {
    var list = (0, _dom["default"])(raw[name]).find("[fill=\"".concat(replaceColor, "\"],[stroke=\"").concat(replaceColor, "\"]"));
    list.each(function (node) {
      if (node.getAttribute('stroke') === replaceColor) {
        node.setAttribute('stroke', color);
      }

      if (node.getAttribute('fill') === replaceColor) {
        node.setAttribute('fill', color);
      }
    });
    cache[key] = list[format]();
  }

  return cache[key];
}