"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createNotification = createNotification;
exports.updateNotification = updateNotification;
exports.openUrl = openUrl;
exports.addBadge = addBadge;
exports.removeBadge = removeBadge;
Object.defineProperty(exports, "getMode", {
  enumerable: true,
  get: function get() {
    return _mode["default"];
  }
});

var web = _interopRequireWildcard(require("./web"));

var electron = _interopRequireWildcard(require("./electron"));

var _mode = _interopRequireDefault(require("./mode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var implementation = web;

if (electron.isElectron) {
  implementation = electron;
}

function createNotification() {
  if (implementation.createNotification) {
    var _implementation;

    return (_implementation = implementation).createNotification.apply(_implementation, arguments);
  }

  return null;
}

function updateNotification() {
  if (implementation.updateNotification) {
    var _implementation2;

    return (_implementation2 = implementation).updateNotification.apply(_implementation2, arguments);
  }

  return null;
}

function openUrl() {
  var _implementation3;

  if (implementation.openUrl) return (_implementation3 = implementation).openUrl.apply(_implementation3, arguments);
  return null;
}

function addBadge() {
  var _implementation4;

  if (implementation.addBadge) return (_implementation4 = implementation).addBadge.apply(_implementation4, arguments);
  return null;
}

function removeBadge() {
  var _implementation5;

  if (implementation.removeBadge) return (_implementation5 = implementation).removeBadge.apply(_implementation5, arguments);
  return null;
}