"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.callbacks = void 0;

/*
1) window.open - onExternal
2) location.href - onRedirect
3) openChannel - onSilentChange
4) router.push, router.replace - onUpdateRouter
*/
var callbacks = function callbacks() {
  var called = {
    onExternal: 0,
    onRedirect: 0,
    onSilentChange: 0,
    onUpdateRouter: 0
  };
  var args = [];
  var map = {
    onExternal: function onExternal() {
      called.onExternal++; // eslint-disable-next-line prefer-spread

      for (var _len = arguments.length, a = new Array(_len), _key = 0; _key < _len; _key++) {
        a[_key] = arguments[_key];
      }

      args.push.apply(args, a);
    },
    onRedirect: function onRedirect() {
      called.onRedirect++; // eslint-disable-next-line prefer-spread

      for (var _len2 = arguments.length, a = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        a[_key2] = arguments[_key2];
      }

      args.push.apply(args, a);
    },
    onSilentChange: function onSilentChange() {
      called.onSilentChange++; // eslint-disable-next-line prefer-spread

      for (var _len3 = arguments.length, a = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        a[_key3] = arguments[_key3];
      }

      args.push.apply(args, a);
    },
    onUpdateRouter: function onUpdateRouter() {
      called.onUpdateRouter++; // eslint-disable-next-line prefer-spread

      for (var _len4 = arguments.length, a = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        a[_key4] = arguments[_key4];
      }

      args.push.apply(args, a);
    }
  };
  return {
    map: map,
    called: called,
    args: args
  };
};

exports.callbacks = callbacks;