"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "openUrl", {
  enumerable: true,
  get: function get() {
    return _openUrl2["default"];
  }
});
exports.updateNotification = exports.createNotification = void 0;

var _openUrl2 = _interopRequireDefault(require("./open-url"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Create native html notification.
 */
var createNotification = function createNotification() {
  if (!window.Notification) return null;
  var properties;
  var callbacks;
  var params; // Handling of changing API for createNotification function, but old desktop clients should also be supported.
  // Please remove within some time.

  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (args[1]) {
    // Handling notifications for old desktop client (grape-electron < 3.0.0)
    ;
    properties = args[0];
    callbacks = args[1];
    params = args[2];
  } else {
    // Handling notifications for new desktop client (grape-electron >= 3.0.0)
    // eslint-disable-next-line prefer-destructuring
    ;
    var _args$ = args[0];
    properties = _args$.properties;
    params = _args$.params;
    callbacks = _args$.callbacks;
  }

  var notification = new Notification(properties.title, _objectSpread({
    body: properties.content,
    silent: true
  }, properties));

  if (properties.requireInteraction) {
    setTimeout(function () {
      notification.close();
    }, params.timeout || 3000);
  }

  if (callbacks.onClick) {
    notification.onclick = function (e) {
      callbacks.onClick(e, notification);
      notification.close();
      window.focus();
      if (window.grapeAppBridge && window.grapeAppBridge.showMainWindow) window.grapeAppBridge.showMainWindow();
    };
  }

  if (callbacks.onClose) {
    notification.onclose = function (e) {
      callbacks.onClose(e, notification);
    };
  }

  return notification;
};
/**
 * Update existing notification
 */


exports.createNotification = createNotification;

var updateNotification = function updateNotification(_ref, props, nextProps) {
  var type = _ref.type;
  var incomingCall = nextProps.incomingCall,
      notification = nextProps.notification;

  if (type === 'calls') {
    var show = incomingCall.show;

    if (!show && show !== props.incomingCall.show && notification.close) {
      notification.close();
    }
  }
};
/**
 * Open an url in browser.
 */


exports.updateNotification = updateNotification;